﻿using UnityEngine;
using System.Collections;


public class Fisica_Jugador : MonoBehaviour {

	public LayerMask layers;
	
	private int divisiones_en_x = 3;
	private int divisiones_en_y = 12;

	public bool colision_a_derecha = false;
	
	public float direccion_h = 0f;
	
	[HideInInspector]
	public bool grounded, wall_jump, stop;

	private Jugador_Control jugador;

	private Animator anim;

	Ray2D ray;
	RaycastHit2D hit;

	public int num_player;
	public bool es_vulnerable = true;

	float escala_inicial;

	void Start(){

		StartCoroutine("player_blink");

		anim = GetComponent<Animator> ();

		escala_inicial = transform.localScale.x;
		es_vulnerable = true;
		jugador = GetComponent<Jugador_Control> ();

	}

	void OnCollisionEnter2D(Collision2D col){

		if (col.gameObject.tag == "Coleccionable" && col.transform.parent) {
				
			Destroy(col.transform.parent.gameObject);
				
			if(num_player == 1)
			Jugador_Control.puntaje_1 +=3;
			if(num_player == 2)
			Jugador_Control.puntaje_2 +=3;

			int anterior = GetComponent<ControlArma>().modo_disparo ;
			GetComponent<ControlArma>().modo_disparo = Random.Range(1,5);
			if(GetComponent<ControlArma>().modo_disparo == anterior) 
				GetComponent<ControlArma>().modo_disparo = 1;
			GetComponent<ControlArma>().Asignar_Arma();

				}

		if (num_player != 0 && col.gameObject.tag == "Malo") {

			if(es_vulnerable && jugador.vida > 0){
			jugador.vida--;

				if(jugador.vida == 0){

					if(num_player == 1){
						Destroy(gameObject);
						Generador_Malos.murio_jugador_1 = true;
					}
					if(num_player == 2){
						Destroy(gameObject);
						Generador_Malos.murio_jugador_2 = true;
					}
				}

			rigidbody2D.velocity += new Vector2(col.gameObject.GetComponent<Fisica_Jugador>().direccion_h * -3f,5f);
			StartCoroutine("player_blink");
			es_vulnerable = false;
			} 
				}

		}

	IEnumerator player_blink(){

		if (num_player == 1) {
						Physics2D.IgnoreLayerCollision (10, 14, true);
						Physics2D.IgnoreLayerCollision (10, 15, true);
				} else {
			Physics2D.IgnoreLayerCollision (11, 14, true);
			Physics2D.IgnoreLayerCollision (11, 15, true);

				}
		for (int i = 0; i < 10; i++) {

			renderer.enabled = (renderer.enabled)? false : true;
			yield return new WaitForSeconds(0.05f);

				}

		es_vulnerable = true;

		if(num_player == 1)
			Physics2D.IgnoreLayerCollision(10,14,false);
		else 
			Physics2D.IgnoreLayerCollision(11,15,false);

	}
	
	void Update () {

		if (grounded) {
						anim.SetBool ("Grounded", true);
						anim.SetBool ("Salto", false);
						anim.SetBool ("Cayendo", false);
				} else {
						anim.SetBool ("Grounded", false);

						if (rigidbody2D.velocity.y < 0)
								anim.SetBool ("Cayendo", true);

						if (rigidbody2D.velocity.y > 0)
								anim.SetBool ("Salto", true);
				}
		if ((rigidbody2D.velocity.x > 0 || rigidbody2D.velocity.y < 0)) {

			anim.SetBool("Caminando", true);

				} else anim.SetBool("Caminando", false);

		Flip();

			if (jugador.input_x > 0){
									
				direccion_h = 1f;
			}
			else if (jugador.input_x < 0){
				direccion_h = -1f;
			}

		float posX = transform.position.x;
		float posY = transform.position.y;
		
		//COLISIONES VERTICALES
		
		grounded = false;
		
		for (int i = 0; i<divisiones_en_x; i ++) {
			
			
			float x = (posX - 0.4f) + (0.4f * i); 
			float y = posY - 1.2f;
			
			ray = new Ray2D(new Vector2(x,y), new Vector2(0,-1));
			
			Debug.DrawRay(ray.origin,ray.direction * 0.25f);

			if (Physics2D.Raycast(ray.origin, ray.direction, 0.25f ,layers)) {
				
				grounded = true;
				
			}
		}
		
		//COLISIONES LATERALES
		
		stop = false;
		wall_jump = false;
		
		for (int i = 0; i<divisiones_en_y; i ++) {
			
			float dir = direccion_h;
			float x = posX + 1f * dir;
			float y = (posY - 1f) + (0.2f * i); 
			
			ray = new Ray2D(new Vector2(x,y), new Vector2(dir,0));
			
			Debug.DrawRay(ray.origin,ray.direction * 0.2f);

			if (Physics2D.Raycast(ray.origin, ray.direction,0.2f,layers)) {
				
				wall_jump = (grounded)? false : true;
				colision_a_derecha = (Mathf.Sign (dir) > 0f) ? true : false; 
				stop = true;
				
			} 
			
			
		}

		//COLISIONES EN DIAGONAL

		if (!grounded && !stop) {

			Vector3 direccion = rigidbody2D.velocity;
			Vector3 o = new Vector2(posX + (0.4f * Mathf.Sign(direccion.x)), posY + (0.4f * Mathf.Sign (direccion.y))); 

			ray = new Ray2D(o,direccion.normalized);

			Debug.DrawRay(ray.origin, ray.direction * 0.1f);

			if (Physics2D.Raycast(ray.origin, ray.direction,0.1f,layers)) {
				grounded = true;
			}
			
			
		}
		
		
	}

	void Flip(){

		if (direccion_h == 1)
						transform.localScale = new Vector2 (escala_inicial, transform.localScale.y);
		else transform.localScale = new Vector2 (-escala_inicial, transform.localScale.y);

	}
}
