﻿using UnityEngine;
using System.Collections;

public class Jugador_Control : MonoBehaviour {
	
	public float velocidad_x;
	private float velocidad_x_inicial;
	public float altura_salto;

	public GameObject esqueleto,esqueleto_con,anim_salto;
	private GameObject anim_salto_inst;

	public int num_player;

	private ControlArma arma;

	[HideInInspector]
	public bool input_salto, input_disparo, es_vulnerable = true;
	[HideInInspector]
	public float input_x;

	public GameObject hueso;
	private bool saltando;
	private bool moverse;
	private bool wall_jumping;
	private bool puede_moverse = true;
	private bool puede_hacer_wall_jump = false;
	private bool disparando = false;

	public int vida = 3;

	public static bool saliendoApp = false;

	public static int puntaje_1, puntaje_2;

	private Fisica_Jugador fisica;

	private TextMesh texto;

	void OnApplicationQuit()
	{
		saliendoApp = true;
	}


	
	void Start(){

		saliendoApp = false;

		if(num_player == 1)
		texto = GameObject.Find ("puntos_jugador_1").GetComponent<TextMesh> ();
		if(num_player == 2)
		texto = GameObject.Find ("puntos_jugador_2").GetComponent<TextMesh> ();

		vida = 3;
		arma = GetComponent<ControlArma> ();
		velocidad_x_inicial = velocidad_x;
		rigidbody2D.fixedAngle = true;
		fisica = GetComponent<Fisica_Jugador> ();

	}

	void OnDestroy(){

		if (!saliendoApp) {
				
			for (int i = 0; i < 3; i++){

				GameObject g = Instantiate(hueso, transform.position, Quaternion.identity) as GameObject;

				Vector3 dir = (i == 1) ? Vector2.right : (i == 2) ? Vector2.right * -1f : Vector2.zero;

				g.rigidbody2D.velocity = new Vector2 (dir.x * -2f, 10f);
				g.rigidbody2D.AddTorque (10f);

			}
						if (anim_salto_inst)
								Destroy (anim_salto_inst);
				}

		}

	void Update(){

		if (num_player == 1) {

			puntaje_1 = (puntaje_1 < 0) ? 0 : puntaje_1;  
			texto.text = (puntaje_1< 10) ? "0" + puntaje_1 + "" : puntaje_1 + "";

			input_salto = Input.GetButtonDown("Jump1");
			input_disparo = Input.GetButtonDown("Disparo1");

				}

		if (num_player == 2) {

			puntaje_2 = (puntaje_2 < 0) ? 0 : puntaje_2;  
			texto.text = (puntaje_2< 10) ? "0" + puntaje_2 + "" : puntaje_2 + "";

			input_salto = Input.GetButtonDown("Jump2");
			input_disparo = Input.GetButtonDown("Disparo2");
			
		}

		if (puede_moverse) {

			if(num_player == 1) input_x = Input.GetAxisRaw ("Horizontal1");
			if(num_player == 2)  input_x = Input.GetAxisRaw ("Horizontal2");

				} else
						input_x = 0f;

		if (input_x != 0 && !fisica.stop) {

		moverse = true;

		} else moverse = false;

		if (fisica.grounded) {

			velocidad_x = velocidad_x_inicial;
			puede_hacer_wall_jump = true;

			if (input_salto){

				if(!anim_salto_inst)
				anim_salto_inst = Instantiate(anim_salto, new Vector2(transform.position.x, transform.position.y - 0.5f), Quaternion.identity) as GameObject;
				Invoke("Borrar_Humo",0.20f);
				saltando = true;
			
			}

				} else {

			velocidad_x = velocidad_x_inicial * 0.75f;

				}

		if (fisica.wall_jump && puede_hacer_wall_jump) {

			puede_moverse = false;
			Invoke ("Volver_a_moverse", 0.25f);

			if(input_salto){


				puede_hacer_wall_jump = false;
				wall_jumping = true;
				puede_moverse = false;
				Invoke ("Volver_a_moverse", 0.5f);

			}

				}

		//para el efecto del disparo.. ese "retraso".. cambiar el boton de disparo.
		if (input_disparo && arma) {

			disparando = true;

				}


	}

	void Borrar_Humo(){

		Destroy (anim_salto_inst);

	}

	void FixedUpdate(){

		if (disparando) {

			disparando = false;
			Vector2 dir = (fisica.direccion_h == 1) ? Vector2.right : Vector2.right * -1f; 
			arma.Disparar(dir, transform.FindChild("punto_disparo").transform.position);


				}

		if (moverse && !fisica.stop) rigidbody2D.velocity = new Vector2 (velocidad_x * input_x, rigidbody2D.velocity.y);
		else if (fisica.stop) rigidbody2D.velocity = new Vector2 (0f, rigidbody2D.velocity.y);

		if (saltando) {

			rigidbody2D.velocity = (new Vector2(rigidbody2D.velocity.x, altura_salto));			
			saltando = false;

				}

		if (wall_jumping) {

			rigidbody2D.velocity = (fisica.colision_a_derecha) ? new Vector2(this.velocidad_x * -1f, altura_salto) :
				new Vector2(this.velocidad_x, altura_salto);

			wall_jumping = false;

				}
	}

	void Volver_a_moverse(){

		puede_moverse = true;

	}


}
